-- Simple Raid Target Icons
--
--------------------------------
--                            --
-- Concept originally by Qzot --
--                            --
--------------------------------

local menu, doubleClick, doubleClickX, doubleClickY;

local function buildMenu()
	if ( menu ) then return; end

	local menu = CreateFrame("button", "SRTIRadialMenu", UIParent);
	menu:SetWidth(100);
	menu:SetHeight(100);
	menu:SetPoint( "CENTER", UIParent, "BOTTOMLEFT", 0, 0 );
	menu:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	menu:RegisterEvent("PLAYER_TARGET_CHANGED");
	menu.p = menu:CreateTexture("SRTIRadialMenuPortrait","BORDER");
	menu.p:SetWidth(40);
	menu.p:SetHeight(40);
	menu.p:SetPoint("CENTER", menu, "CENTER", 0, 0 );
	menu.b = menu:CreateTexture("SRTIRadialMenuBorder", "BACKGROUND");
	menu.b:SetTexture("Interface\\Minimap\\UI-TOD-Indicator");
	menu.b:SetWidth(80);
	menu.b:SetHeight(80);
	menu.b:SetTexCoord(0.5,1,0,1);
	menu.b:SetPoint("CENTER", menu, "CENTER", 10, -10 );
	for i=1, 8 do
		menu[i] = menu:CreateTexture("SRTIRadialMenu"..i,"OVERLAY");
	end

	menu:SetScript("OnUpdate", function()
			local saved, index = this.i, GetRaidTargetIndex("target");
			local curtime = GetTime();
			if ( not this.h ) then
				if ( not UnitExists("target") or ( not UnitPlayerOrPetInRaid("target") and UnitIsDeadOrGhost("target") ) ) then
					if ( menu.portrait ) then
						this:Hide();
						return;
					else
						this.h = curtime;
					end
				elseif ( menu.portrait ) then
					menu.portrait = nil;
					if ( not UnitIsUnit("target","mouseover") ) then
						this:Hide();
						return;
					end
					PlaySound("igMainMenuOptionCheckBoxOn");
					SetPortraitTexture( menu.p, "target" );
				end

				local x, y = GetCursorPosition();
				local s = menu:GetEffectiveScale();
				local mx, my = menu:GetCenter();
				x = x / s;
				y = y / s;

				local a, b = y - my, x - mx;

				local dist = floor(math.sqrt( a*a + b*b ));

				this.i = nil;

				if ( dist > 60 ) then
					if ( dist > 200 ) then
						this.l = nil;
						this.h = curtime;
						this.s = nil;
						PlaySound("igMainMenuOptionCheckBoxOff");
					elseif ( not this.l ) then
						this.l = curtime;
					end
				else
					this.l = nil;

					if ( dist > 20 and dist < 50 ) then
						local pos = math.deg(math.atan2( a, b )) + 27.5;
						this.i = mod(11-ceil(pos/45),8)+1;
					end
				end

				for i=1, 8 do
					local t = this[i];
					if ( index == i ) then
						t:SetTexCoord(0,1,0,1);
						t:SetTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up");
					else
						t:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons");
						SetRaidTargetIconTexture(t,i);
					end
				end

				if ( ( this.c or IsControlKeyDown() ) and this.i ) then
					this:Click();
				end

				if ( this.c == 0 and not IsControlKeyDown() ) then
					this.c = nil;
				end
			end

			if ( this.s ) then
				local status = curtime - this.s;
				if ( status > 0.1 ) then
					menu.p:SetAlpha(1);
					menu.b:SetAlpha(1);
					for i=1, 8 do
						local t, radians = this[i], (0.375 - i/8) * 360;
						t:SetPoint("CENTER", this, "CENTER", 36*cos(radians), 36*sin(radians) );
						t:SetAlpha(0.5);
						t:SetWidth(18);
						t:SetHeight(18);
					end
					this.s = nil;
				else
					status = status / 0.1;
					menu.p:SetAlpha(status);
					menu.b:SetAlpha(status);
					for i=1, 8 do
						local t, radians = this[i], (0.375 - i/8) * 360;
						t:SetPoint("CENTER", this, "CENTER", (20*status + 16)*cos(radians), (20*status + 16)*sin(radians) );
						if ( i == index ) then
							t:SetAlpha(status);
						else
							t:SetAlpha(0.5*status);
						end
						t:SetWidth(9*status + 9);
						t:SetHeight(9*status + 9);
					end
				end
			elseif ( this.h ) then
				local status = curtime - this.h;
				if ( status > 0.1 ) then
					this.h = nil;
					this:Hide();
				else
					status = 1 - status / 0.1;
					menu.p:SetAlpha(status);
					menu.b:SetAlpha(status);
					for i=1, 8 do
						local t, radians = this[i], (0.375 - i/8) * 360;
						if ( this.i == i ) then
							t:SetWidth(36-18*status);
							t:SetHeight(36-18*status);
							t:SetAlpha(min(4*status,1));
						else
							t:SetPoint("CENTER", this, "CENTER", (20*status + 16)*cos(radians), (20*status + 16)*sin(radians) );
							t:SetAlpha(0.75*status);
							t:SetWidth(18*status);
							t:SetHeight(18*status);
						end
					end
				end
			else
				for i=1, 8 do
					local t = this[i];
					if ( i == index ) then
						t:SetAlpha(1);
					else
						t:SetAlpha(0.75);
					end
					t:SetWidth(18);
					t:SetHeight(18);
				end
			end

			if ( this.i ) then
				local t = this[this.i];
				local a, w = t:GetAlpha(), t:GetWidth();

				if ( not this.t or saved ~= this.i ) then
					this.t = curtime;
				end
				local s = 1 + min( (curtime - this.t)/0.05, 1 );

				t:SetAlpha(min(a+0.125*s,1));
				t:SetWidth(w*s);
				t:SetHeight(w*s);
			end

			if ( this.l ) then
				local status = curtime - this.l;
				if ( status > 0.75 ) then
					this.h = curtime;
					this.l = nil
					this.s = nil
					this.i = nil;
					PlaySound("igMainMenuOptionCheckBoxOff");
				end
			end
		end
		);

	menu:SetScript("OnClick", function()
			if ( not this.h ) then
				local index = GetRaidTargetIndex("target");
				if ( ( arg1 == "RightButton" and index and index > 0 ) or ( this.i and this.i == index ) ) then
					this.i = index;
					PlaySound("igMiniMapZoomOut");
					SetRaidTarget("target", 0);
				elseif ( this.i ) then
					PlaySound("igMiniMapZoomIn");
					SetRaidTarget("target", this.i);
				else
					PlaySound("igMainMenuOptionCheckBoxOff");
				end
				this.s = nil;
				this.h = GetTime();
			end
		end
		);

	menu:SetScript("OnEvent", function()
			if ( this:IsVisible() and not this.e and not this.h ) then
				this.i = nil;
				this.s = nil;
				this.h = GetTime();
				PlaySound("igMainMenuOptionCheckBoxOff");
			end
			this.e = nil;
		end
		);

	return menu;
end

function SRTIRadialMenu_Show()

	if ( not IsPartyLeader() ) then
		local num = GetNumRaidMembers();
		if ( num == 0 ) then return; end

		local _, rank = GetRaidRosterInfo(num);
		if ( rank == 0 ) then return; end
	end

	if ( not menu ) then
		menu = buildMenu();
	end
	menu.s = GetTime();
	menu.h = nil;
	menu.i = nil;
	menu.l = nil;
	menu.e = 1;
	menu.portrait = 1;

	local x,y = GetCursorPosition();
	local s = menu:GetEffectiveScale();
	menu:SetPoint( "CENTER", UIParent, "BOTTOMLEFT", x/s, y/s );
	menu:Show();
end

local OnMouseUp = WorldFrame:GetScript("OnMouseUp");

WorldFrame:SetScript("OnMouseUp", function()
		if ( arg1 == "LeftButton" ) then
			local curtime = GetTime();
			local x, y = GetCursorPosition();
			if ( IsControlKeyDown() or ( doubleClick and curtime - doubleClick < 0.25 and abs(x-doubleClickX) < 20 and abs(y-doubleClickY) < 20 ) ) then
				SRTIRadialMenu_Show();
				if ( menu ) then
					if ( IsControlKeyDown() ) then
						menu.c = 0;
					else
						menu.c = 1;
					end
				end
				doubleClick = nil;
			else
				doubleClick = curtime;
			end
			doubleClickX, doubleClickY = x, y;
		end
		if ( OnMouseUp ) then
			OnMouseUp();
		end
	end
	);
